<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: Plugin</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: Plugin</h1>

    




<section>

<header>
    
        <h2><span class="attribs"><span class="type-signature"></span></span>
            <span class="ancestors"><a href="module-plugin.html">plugin</a>~</span>Plugin<span class="signature">(schema)</span><span class="type-signature"></span></h2>
        
            <div class="class-description"><p>provides basic functions for plai plugins</p></div>
        
    
</header>

<article>
    <div class="container-overview">
    
        

    
    <h2>Constructor</h2>
    

    
    <h4 class="name" id="Plugin"><span class="type-signature"></span>new Plugin<span class="signature">(schema)</span><span class="type-signature"></span></h4>
    

    











    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>schema</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>js object notation schema defining the plugins necessities for
settings, cue properties and, if plugin uses collections, creating new items</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line15">line 15</a>
    </li></ul></dd>
    

    

    

    
</dl>


















    
    </div>

    

    

    

    

    

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id="cancel"><span class="type-signature"></span>cancel<span class="signature">(listener)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>called when a session wants to cancel a listener</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>listener</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>all data that was stored about the listener</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line79">line 79</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="command"><span class="type-signature"></span>command<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>handle commands forwarded by game</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line105">line 105</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="cue"><span class="type-signature"></span>cue<span class="signature">(data)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>called when cue was triggered that contains any property of this plugin
if a listener type is cued, cue may return data that will be stored and recalled
whenever the listener is retriggered or canceled</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>cue data entered by user</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line69">line 69</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="removed"><span class="type-signature"></span>removed<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>is called the moment the plugin was disabled in a game</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>config.game</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>Name of game that required this module</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line98">line 98</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="schemaUpdate"><span class="type-signature"></span>schemaUpdate<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>write changed schema to plugin document in plugins database</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line129">line 129</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="settings"><span class="type-signature"></span>settings<span class="signature">(new_settings)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>called when settings based on the schema the module provides, are changed</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>new_settings</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>changed settings based on perferences schema of this plugin</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line89">line 89</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="setup"><span class="type-signature"></span>setup<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>is called once after the plugin is required by the game
creates collections as objects and in database if schema defines them</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>config.game</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>Name of game that required this module</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>config.db</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>Game Databse collection connector</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>config.app</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>Express app instance</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>config.socket</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>socket.io namespace routed to /<pluginname></p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>config.url</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>external webaddress as entered by user directing to node server</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_plugin.js.html">plugins/plugin.js</a>, <a href="plugins_plugin.js.html#line39">line 39</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-plugin-Collection.html">Collection</a></li><li><a href="module-plugin-Item.html">Item</a></li><li><a href="module-plugin-Plugin.html">Plugin</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:26:50 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>